#pragma once

#include "system.h"

// an image object with jpeg facility
class Image sealed {
public:
	Image() : m_dwWidth( 0 ), m_dwHeight( 0 ) {}
	Image( const dword & _dwWidth, const dword & _dwHeight ) : m_dwWidth( _dwWidth ), m_dwHeight( _dwHeight ), m_data( new byte[ _dwWidth * _dwHeight * 3 ] ) {}

public:
	operator byte * () const { return m_data.get(); }
	const dword & GetWidth() const { return m_dwWidth; }
	const dword & GetHeight() const { return m_dwHeight; }

public:
	const bool Load( const wstring & _sFileName );
	const bool Save( const wstring & _sFileName, const unsigned char _qualityPercent = 100 );

private:
	dword m_dwWidth;
	dword m_dwHeight;
	unique_ptr< byte > m_data;
};